##TODO :

import ioengine, data
import pygame, math, random
from pygame.locals import *



#Import psyco
try:
    import psyco
    psyco.background()
except Exception,e:
    print "No psyco" + str(e)

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'




## functions
#load sound stolen from chimp tutorial
def load_sound(name):
    class NoneSound:
        def play(self): pass
    if not pygame.mixer:
        return NoneSound()
    fullname = data.filepath(name)
    try:
        sound = pygame.mixer.Sound(fullname)
    except pygame.error, message:
        print 'Cannot load sound:', fullname
        raise SystemExit, message
    return sound

def load_image(name, colorkey=None):
    fullname = data.filepath(name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', name
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image#, image.get_rect()


def newspot():
    x=0
    while 1:
        x+=1
        y=x%4
        if y==0:
            yield (0,(x*29)%600)
        elif y==1:
            yield (800,(x*29)%600)
        if y==2:
            yield ((x*29)%800,0)
        if y==3:
            yield ((x*29)%800,600)

#magnitude and direction splitter
def magdir((x,y)):
    mag=math.hypot(x,y)
    if mag:
        dir=(x/mag,y/mag)
    else: 
        dir = (0,0)
    return mag,dir

def mult(tup,amt):
    return (tup[0]*amt,tup[1]*amt)
#check for collision
def collision(b1,b2):
    if pygame.Rect(((int(b1.pos[0]-b1.radius),int(b1.pos[1]-b1.radius)),(2*b1.radius,2*b1.radius))).colliderect(((int(b2.pos[0]-b2.radius),int(b2.pos[1]-b2.radius)),(2*b2.radius,2*b2.radius))):
        
        b1.collide(b2)
        b2.collide(b1)
        return 1
    else:
        return 0
##Classes
#base class
class powerup:
    def __init__(self,pos):
        self.pos=pos
        self.type=random.randint(0,1)
        self.color=((96,128,96),(200,200,100))[self.type]
        self.death=load_sound("powerup.wav")
        self.radius=15
        self.health=100
        self.damage=0
        
    def draw(self,screen):
        pygame.draw.circle(screen,self.color,self.pos,self.radius)
        
    def collide(self,player):
        if self.type==1:
            self.health=0
        
        if player.health<120 and self.type==0:
            self.health=0
            player.health+=10
            player.color=(player.color[0]+20,player.color[1]+20,player.color[2]+10)
            

class base:
    def __init__(self,color=(200,200,200),radius=10,pos=(200,300),speed=1):
        self.pos=pos
        self.vel=(0,0)
        self.acc=(0,0)
        self.radius=radius
        self.color=color
        self.health=100
        self.death=load_sound("death.wav")
        self.speed=speed
        self.damage=10
        self.image=load_image("rob4.bmp",-1)
        
    def collide(self,enemy):
        self.health-=enemy.damage
        
    def draw(self,screen):
        pygame.draw.rect(screen,self.color,((int(self.pos[0]-self.radius),int(self.pos[1]-self.radius)),(2*self.radius,2*self.radius)))  

    def update(self):
        self.vel=(self.vel[0]+self.acc[0],self.vel[1]+self.acc[1])
        self.pos=(self.pos[0]+self.vel[0]*self.speed,self.pos[1]+self.vel[1]*self.speed)
        self.vel=(self.vel[0]*0.94,self.vel[1]*0.94)
class bot(base):
    def draw(self,screen):
        screen.blit(self.image,(self.pos[0]-self.radius,self.pos[1]-self.radius))
        
    def chase(self,player):
        x=self.pos[0]-player.pos[0]
        y=self.pos[1]-player.pos[1]
        m,d=magdir(self.vel)
        m2,d2=magdir((x,y))
        predot=x*self.vel[0]+y*self.vel[1]
        if m and m2:
            dotproduct=predot/m/m2
        else: dotproduct=0
        
        if self.acc == (0,0) or dotproduct<-0.5 and m2<1000:
            if abs(x-y)<10:
                self.acc=(0.07071*cmp(0,x),0.07071*cmp(0,y))
            elif abs(x)>abs(y):
                self.acc=(0.1*cmp(0,x),0)
            else:
                self.acc=(0,0.1*cmp(0,y))

class guard(base):
    def chase(self,player):
        mag,dir=magdir(self.vel)
        newmag,newdir=magdir((player.pos[0]-self.pos[0],player.pos[1]-self.pos[1]))
        rotper=0.93
        
        d=[
        [50,120,250],
        [0.3,0.7,1.1],
        [rotper,0.945,0.92]
        ]
        
        
        if d[0][0]<=newmag<d[0][1]:
            per=(newmag-d[0][0])/(d[0][1]-d[0][0])
            mag+=d[1][0]*(1-per)+d[1][1]*per
            rotper=d[2][0]*(1-per)+d[2][1]*per
        elif d[0][1]<=newmag<d[0][2]:
            per=(newmag-d[0][1])/(d[0][2]-d[0][1])
            mag+=d[1][1]*(1-per)+d[1][2]*per
            rotper=d[2][1]*(1-per)+d[2][2]*per
        elif d[0][2]<=newmag:
            mag+=d[1][2]
            rotper=d[2][2]
            
        
        newdir=(dir[0]*rotper+newdir[0]*(1-rotper),dir[1]*rotper+newdir[1]*(1-rotper))
        self.vel=mult(newdir,mag)


#block class
class block(base):
    def collide(self,enemy):
        if enemy.damage:
            self.health-=enemy.damage
            self.color=(abs(self.health*2),abs(self.health*2),abs(self.health))
            self.death.play()
            
    def update(self):
        self.vel=(self.vel[0]+self.acc[0],self.vel[1]+self.acc[1])
        self.pos=(self.pos[0]+self.vel[0],self.pos[1]+self.vel[1])
        self.acc=(self.acc[0]*0.9,self.acc[1]*0.9)
        self.vel=(self.vel[0]*0.94,self.vel[1]*0.94)

## mainloop
def main():
    ##init
    pygame.init()
    clock=pygame.time.Clock()
    pygame.display.set_caption('RoBLOCK')
    pygame.mouse.set_visible(0)
    screen=pygame.display.set_mode((800,600))
    player=block(color=(200,200,100))
    #robot=bot(radius=10)
    player.pos=(400,300)
    player.damage=9000
    ioe=ioengine.ioe()
    enemylist=[]
    guards=[]
    
        
    powerlist=[]
    ticks=0
    score=0
    
    ns=newspot()

    #~ if pygame.font:
        #~ font = pygame.font.Font(None, 36)
        #~ text = font.render("Pummel The Chimp, And Win $$$", 1, (10, 10, 10))
        #~ textpos = text.get_rect(centerx=background.get_width()/2)
        #~ background.blit(text, textpos)
    
    ##gameloop
    while not ioe.quit and player.health>0:
        clock.tick(30)
        ticks+=1
        score+=1
        
        if not (-80<player.pos[0]<880 and -80<player.pos[1]<680):
            player.health-=1
        
        if not ticks%250:
            powerlist.append(powerup((random.randint(100,700),random.randint(60,540))))
        screen.fill((255,255,255))
        ioe.update(pygame.event.get())
        pygame.draw.circle(screen,(230,230,230),(400,300),ticks//50)
        #~pygame.draw.circle(screen,(96,96,132),(700,400),int(abs(player.vel[0])+abs(player.vel[1])))
        #~pygame.draw.circle(screen,(96,96,132),(500,400),int(abs(player.acc[0]*10)+abs(player.acc[1]*10)))
        player.update()
        
        for g in guards:
            g.chase(player)
            g.update()
            g.draw(screen)
        guards=[g for g in guards if g.health>0]
        
        for i in range(len(powerlist)):
            
            if collision(powerlist[i],player):
                if powerlist[i].type==1:
                    guards.append(guard(radius=8,color=(220,200,100)))
                    guards[-1].damage=200
                    guards[-1].speed+=random.random()/2
                    guards[-1].acc=(((random.random()-0.5)/200,(random.random()-0.5)/200))
            powerlist[i].draw(screen)
            powerlist[i].health-=0.2
        powerlist=[p for  p in powerlist if p.health>0]
        
        
        
        for i in range(len(enemylist)):
            
            enemylist[i].chase(player)
            enemylist[i].update()
            collision(enemylist[i],player)
            for g in guards:
                collision(enemylist[i],g)
            for j in range(len(enemylist)-i-1):
                collision(enemylist[i],enemylist[i+j+1])
            enemylist[i].draw(screen)
         
        enemylist=[e for  e in enemylist if e.health>0 and -100<e.pos[0]<900 and -100<e.pos[1]<700]
        
        while len(enemylist) <min(50,(math.cos(math.pi/160*ticks)+0.9)*(math.sqrt(ticks)//2)):
            enemylist.append(bot((128,128,128),5,ns.next(),0.15+4*random.random()))
            score+=1
            
        player.draw(screen)
        for k in ioe.down:
            #boost.play()
            #Make multiple keys possible.
            if k==K_LEFT:
                player.acc=(player.acc[0]-1.2,player.acc[1])
            elif k==K_RIGHT:
                player.acc=(player.acc[0]+1.2,player.acc[1])
            elif k==K_UP:
                player.acc=(player.acc[0],player.acc[1]-1.2)
            elif k==K_DOWN:
                player.acc=(player.acc[0],player.acc[1]+1.2)
            elif k==K_ESCAPE:
                ioe.quit+=[1]
        for k in ioe.pressed:
            if k==K_LEFT:
                player.vel=(player.vel[0]-0.35,player.vel[1])
            elif k==K_RIGHT:
                player.vel=(player.vel[0]+0.35,player.vel[1])
            elif k==K_UP:
                player.vel=(player.vel[0],player.vel[1]-0.35)
            elif k==K_DOWN:
                player.vel=(player.vel[0],player.vel[1]+0.35)
        pygame.display.flip()
    print ticks/30
if __name__ == "__main__":
    main()